# Assign Project

[![Python Version](https://img.shields.io/badge/python-3.8.2-brightgreen.svg)](https://python.org)
[![Django Version](https://img.shields.io/badge/django-3.0.6-brightgreen.svg)](https://djangoproject.com)

End of course project, done by:

    - Estefani Paredes Valera

## 1. A description of each directory in the source code

```bash
myega_drop_boxes/
    
    accounts/
        migrations/
            __init__.py
        static/
            css/
                default.css
                fonts.css
                mystyle.css
            fonts/
            images/
        templates/
            accounts/
        __init__.py
        admin.py
        apps.py
        forms.py
        models.py
        tests.py
        urls.py
        views.py
    
    myega_drop_boxes/
        __init__.py
        asgi.py
        settings.py
        urls.py
        wsgi.py

    db.sqlite3
    geckodriver.log
    manage.py

```
These files are:
-   The outer **myega_drop_boxes** root directory is a container for our project.
-   The **accounts/** directory is where our application is located.
-   In the **accounts/migrations/** directory where the migrations of our app are saved. Migrations are the changes that are made in the models (and therefore in the database).
-   **accounts/static/css/** where are the style files.
-   **accounts/static/fonts/** where are fonts (fontawesome).
-   **accounts/static/images/** where are images.
-   **accounts/accounts/** is a directory containing the templates used in **views.py**.
-   **accounts/__init__.py** is an empty file that tells Python that this directory should be considered a Python package. [Read more about packages](https://docs.python.org/3/tutorial/modules.html#tut-packages).
-   **accounts/admin.py** where the administrator url is configured. Generating admin sites for your staff or clients to add, change, and delete content is tedious work that doesn’t require much creativity. For that reason, Django entirely automates creation of admin interfaces for models. It reads metadata from your models to provide a quick, model-centric interface where trusted users can manage content on your site. [File](accounts/admin.py)
-   **accounts/apps.py** where is the name of our app so that it can be called from **myega_drop_boxes/settings.py**.[File](accounts/apps.py)
-   **accounts/forms.py** contains forms that are used in **views.py**. Django provides a rich framework to facilitate the creation of forms and the manipulation of form data.[File](accounts/forms.py)
-   **accounts/models.py** contains models to create the tables in the database. Django provides an abstraction layer (the “models”) for structuring and manipulating the data of your Web application.[File](accounts/models.py)
-   **accounts/tests.py** contain the app tests.[File](accounts/tests.py)
-   **accounts/urls.py** contains the urls of the application. It is where the functions that are in views are called.[File](accounts/urls.py)
-   **accounts/views.py** is where functions and templates are called. Django has the concept of “views” to encapsulate the logic responsible for processing a user’s request and for returning the response.[File](accounts/views.py)
-   The **myega_drop_boxes** directory contains the configuration files of our project. 
-   **myega_drop_boxes/ __init__.py** is an empty file that tells Python that this directory should be considered a Python package. [Read more about packages](https://docs.python.org/3/tutorial/modules.html#tut-packages). [File](myega_drop_boxes/__init__.py)
-   **myega_drop_boxes/asgi.py** is an entry-point for ASGI-compatible web servers to serve your project. See [How to deploy with ASGI](https://docs.djangoproject.com/en/3.0/howto/deployment/asgi/) for more details. [File](myega_drop_boxes/asgi.py)
-   **myega_drop_boxes/settings.py** where are Settings/configuration for this Django project. [Django settings](https://docs.djangoproject.com/en/3.0/topics/settings/) will tell you all about how settings work. [File](myega_drop_boxes/settings.py)
-   **myega_drop_boxes/urls.py** where are the URL declarations for this Django project; a “table of contents” of your Django-powered site. You can read more about URLs in [URL dispatcher](https://docs.djangoproject.com/en/3.0/topics/http/urls/). [File](myega_drop_boxes/urls.py)
-   **myega_drop_boxes/wsgi.py** is an entry-point for WSGI-compatible web servers to serve your project. See [How to deploy with WSGI](https://docs.djangoproject.com/en/3.0/howto/deployment/wsgi/) for more details. [File](myega_drop_boxes/wsgi.py)
-   **db.sqlite3** is the default database generated by Django.
-   **geckodriver.log** is a Software testing. It is used in **test.py** [What is GeckoDriver? Selenium](https://www.linkedin.com/pulse/what-geckodriver-amith-wijesiri)
-   **manage.py** is a command-line utility that lets you interact with this Django project in various ways. You can read all the details about manage.py in [django-admin and manage.py](https://docs.djangoproject.com/en/3.0/ref/django-admin/).


## 2. The location of the main() function in your program.
```bash
    accounts/
        migrations/
            __init__.py
        static/
            css/
                default.css
                fonts.css
                mystyle.css
            fonts/
            images/
        templates/
            accounts/
        __init__.py
        admin.py
        apps.py
        forms.py
        models.py
        tests.py
        urls.py
        views.py
```
-   The functionalities of our application are found in the **accounts/** folder.
-   The functions are in **views.py**. [File](accounts/views.py)


## 3. Running the Project Locally.

The essential first step is to [install python 3.8.2](https://linuxize.com/post/how-to-install-python-3-8-on-ubuntu-18-04/). We work in Ubuntu 18.04, the commands are:

```bash
sudo apt update
sudo apt install software-properties-common
sudo add-apt-repository ppa:deadsnakes/ppa
sudo apt install python3.8
python3.8 --version
```

Now, clone the repository to your local machine:

```bash
https://gitlab.com/estefani.val34/ega_box.git
```

Install the requirements (you need to have installed the pip):

```bash
cd ega_box/
python -m pip install Django
python -m pip install selenium
python3 -m pip install requests
pip3 install pytest
pip install pysqlite3
```

Apply the migrations:

```bash
python manage.py migrate
```

Finally, run the development server:

```bash
python manage.py runserver
```

The project will be available at **127.0.0.1:8000**.



